#!/usr/bin/python

# Rauschunterdrueckung mittels Median-Filter
#
# Achtung: dieses Programm arbeitet nur mit Grauwert-Bildern!
#
# GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/

import Image
import sys

imIn = Image

if len( sys.argv ) > 1:
    imIn = Image.open(sys.argv[1])
else:
    print "Missing argument!\n Syntax program-name image-file\n"
    exit(0)

# image dimensions
width, height = imIn.size

# create output image
imOut = Image.new( imIn.mode, (width, height) )

# iterate over image
for y in range( 1, height-1 ):
    for x in range( 1, width-1 ):

        # create list of the 3x3 pixel neighborhood
        neighborhood = []
        for j in range( -1,  2):
            for i in range( -1,  2):
                neighborhood.append( imIn.getpixel( (x+i, y+j) ) )

        # find median of 9 = 5th smallest value
        neighborhood.sort()

        # replace pixel with "filtered" value
        imOut.putpixel( (x, y), neighborhood[4] );

# display input and output image
imIn.show()
imOut.show()

#vim:expandtab:
