#!/usr/bin/python

# Sharpening mittels Laplace-Operator
#
# Achtung: dieses Programm arbeitet nur mit Grauwert-Bildern!
#
# GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/


import Image
import sys

imIn = Image
if len( sys.argv ) > 1:
    imIn = Image.open(sys.argv[1])
else:
    print "Missing argument!\n Syntax program-name image-file\n"
    exit(0)

# image dimensions
width,  height = imIn.size

# create output image
imOut = Image.new( imIn.mode,  (width, height) )

# mask = Identity - Laplace
# -> Image * mask = Image - Laplace(image)
filter_kernel= [ [0,  -1,  0],  [-1,  5,  -1],  [0,  -1,  0] ]

# iterate over image
for y in range( 1, height-1 ):
    for x in range( 1, width-1 ):

        value = 0
        for j in range( -1,  2):
            for i in range( -1,  2):
                value += imIn.getpixel( (x+i, y+j) ) * filter_kernel[i][j] # correlation

        value = min( 255, max( value, 0 ) )         # clamp to [0,255] and write result to output image

        imOut.putpixel( (x, y),  value )

# display input and output image
imIn.show()
imOut.show()


#vim:expandtab:
